/* ZGUtilities.c generated by valac 0.56.14, the Vala compiler
 * generated from ZGUtilities.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2011 Collabora Ltd.
 * Copyright (c) 2012 Manish Sinha <manishsinha@ubuntu.com>
 * Copyright (c) 2014 elementary LLC. ((http://launchpad.net/switchboard-plug-security-privacy)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Corentin Noël <tintou@mailoo.org>
 *              Siegfried-Angel Gevatter Pujals <siegfried@gevatter.com> (from Activity-Log-Manager)
 *              Seif Lotfy <seif@lotfy.com> (from Activity-Log-Manager)
 */

#include "security-privacy.h"
#include <zeitgeist-datamodel.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

VALA_EXTERN gboolean security_privacy_utilities_check_field_match (const gchar* property,
                                                       const gchar* template_property,
                                                       const gchar* property_name);
static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);

gboolean
security_privacy_utilities_matches_event_template (ZeitgeistEvent* event,
                                                   ZeitgeistEvent* template_event)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gboolean result;
#line 28 "../src/ZGUtilities.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 28 "../src/ZGUtilities.vala"
	g_return_val_if_fail (template_event != NULL, FALSE);
#line 29 "../src/ZGUtilities.vala"
	_tmp0_ = zeitgeist_event_get_interpretation (event);
#line 29 "../src/ZGUtilities.vala"
	_tmp1_ = _tmp0_;
#line 29 "../src/ZGUtilities.vala"
	_tmp2_ = zeitgeist_event_get_interpretation (template_event);
#line 29 "../src/ZGUtilities.vala"
	_tmp3_ = _tmp2_;
#line 29 "../src/ZGUtilities.vala"
	if (!security_privacy_utilities_check_field_match (_tmp1_, _tmp3_, "ev-int")) {
#line 30 "../src/ZGUtilities.vala"
		result = FALSE;
#line 30 "../src/ZGUtilities.vala"
		return result;
#line 85 "ZGUtilities.c"
	}
#line 34 "../src/ZGUtilities.vala"
	_tmp4_ = zeitgeist_event_get_manifestation (event);
#line 34 "../src/ZGUtilities.vala"
	_tmp5_ = _tmp4_;
#line 34 "../src/ZGUtilities.vala"
	_tmp6_ = zeitgeist_event_get_manifestation (template_event);
#line 34 "../src/ZGUtilities.vala"
	_tmp7_ = _tmp6_;
#line 34 "../src/ZGUtilities.vala"
	if (!security_privacy_utilities_check_field_match (_tmp5_, _tmp7_, "ev-mani")) {
#line 35 "../src/ZGUtilities.vala"
		result = FALSE;
#line 35 "../src/ZGUtilities.vala"
		return result;
#line 101 "ZGUtilities.c"
	}
#line 39 "../src/ZGUtilities.vala"
	_tmp8_ = zeitgeist_event_get_actor (event);
#line 39 "../src/ZGUtilities.vala"
	_tmp9_ = _tmp8_;
#line 39 "../src/ZGUtilities.vala"
	_tmp10_ = zeitgeist_event_get_actor (template_event);
#line 39 "../src/ZGUtilities.vala"
	_tmp11_ = _tmp10_;
#line 39 "../src/ZGUtilities.vala"
	if (!security_privacy_utilities_check_field_match (_tmp9_, _tmp11_, "ev-actor")) {
#line 40 "../src/ZGUtilities.vala"
		result = FALSE;
#line 40 "../src/ZGUtilities.vala"
		return result;
#line 117 "ZGUtilities.c"
	}
#line 43 "../src/ZGUtilities.vala"
	if (zeitgeist_event_num_subjects (event) == 0) {
#line 44 "../src/ZGUtilities.vala"
		result = TRUE;
#line 44 "../src/ZGUtilities.vala"
		return result;
#line 125 "ZGUtilities.c"
	}
	{
		gint i = 0;
#line 47 "../src/ZGUtilities.vala"
		i = 0;
#line 131 "ZGUtilities.c"
		{
			gboolean _tmp12_ = FALSE;
#line 47 "../src/ZGUtilities.vala"
			_tmp12_ = TRUE;
#line 47 "../src/ZGUtilities.vala"
			while (TRUE) {
#line 47 "../src/ZGUtilities.vala"
				if (!_tmp12_) {
#line 140 "ZGUtilities.c"
					gint _tmp13_;
#line 47 "../src/ZGUtilities.vala"
					_tmp13_ = i;
#line 47 "../src/ZGUtilities.vala"
					i = _tmp13_ + 1;
#line 146 "ZGUtilities.c"
				}
#line 47 "../src/ZGUtilities.vala"
				_tmp12_ = FALSE;
#line 47 "../src/ZGUtilities.vala"
				if (!(i < zeitgeist_event_num_subjects (event))) {
#line 47 "../src/ZGUtilities.vala"
					break;
#line 154 "ZGUtilities.c"
				}
				{
					gint j = 0;
#line 48 "../src/ZGUtilities.vala"
					j = 0;
#line 160 "ZGUtilities.c"
					{
						gboolean _tmp14_ = FALSE;
#line 48 "../src/ZGUtilities.vala"
						_tmp14_ = TRUE;
#line 48 "../src/ZGUtilities.vala"
						while (TRUE) {
#line 167 "ZGUtilities.c"
							ZeitgeistSubject* _tmp16_;
							ZeitgeistSubject* _tmp17_;
							ZeitgeistSubject* _tmp18_;
							ZeitgeistSubject* _tmp19_;
							gboolean _tmp20_;
#line 48 "../src/ZGUtilities.vala"
							if (!_tmp14_) {
#line 175 "ZGUtilities.c"
								gint _tmp15_;
#line 48 "../src/ZGUtilities.vala"
								_tmp15_ = j;
#line 48 "../src/ZGUtilities.vala"
								j = _tmp15_ + 1;
#line 181 "ZGUtilities.c"
							}
#line 48 "../src/ZGUtilities.vala"
							_tmp14_ = FALSE;
#line 48 "../src/ZGUtilities.vala"
							if (!(j < zeitgeist_event_num_subjects (template_event))) {
#line 48 "../src/ZGUtilities.vala"
								break;
#line 189 "ZGUtilities.c"
							}
#line 49 "../src/ZGUtilities.vala"
							_tmp16_ = zeitgeist_event_get_subject (event, i);
#line 49 "../src/ZGUtilities.vala"
							_tmp17_ = _tmp16_;
#line 49 "../src/ZGUtilities.vala"
							_tmp18_ = zeitgeist_event_get_subject (template_event, j);
#line 49 "../src/ZGUtilities.vala"
							_tmp19_ = _tmp18_;
#line 49 "../src/ZGUtilities.vala"
							_tmp20_ = security_privacy_utilities_matches_subject_template (_tmp17_, _tmp19_);
#line 49 "../src/ZGUtilities.vala"
							_g_object_unref0 (_tmp19_);
#line 49 "../src/ZGUtilities.vala"
							_g_object_unref0 (_tmp17_);
#line 49 "../src/ZGUtilities.vala"
							if (_tmp20_) {
#line 50 "../src/ZGUtilities.vala"
								result = TRUE;
#line 50 "../src/ZGUtilities.vala"
								return result;
#line 211 "ZGUtilities.c"
							}
						}
					}
				}
			}
		}
	}
#line 55 "../src/ZGUtilities.vala"
	result = FALSE;
#line 55 "../src/ZGUtilities.vala"
	return result;
#line 223 "ZGUtilities.c"
}

gboolean
security_privacy_utilities_matches_subject_template (ZeitgeistSubject* subject,
                                                     ZeitgeistSubject* template_subject)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	gboolean result;
#line 58 "../src/ZGUtilities.vala"
	g_return_val_if_fail (subject != NULL, FALSE);
#line 58 "../src/ZGUtilities.vala"
	g_return_val_if_fail (template_subject != NULL, FALSE);
#line 59 "../src/ZGUtilities.vala"
	_tmp0_ = zeitgeist_subject_get_uri (subject);
#line 59 "../src/ZGUtilities.vala"
	_tmp1_ = _tmp0_;
#line 59 "../src/ZGUtilities.vala"
	_tmp2_ = zeitgeist_subject_get_uri (template_subject);
#line 59 "../src/ZGUtilities.vala"
	_tmp3_ = _tmp2_;
#line 59 "../src/ZGUtilities.vala"
	if (!security_privacy_utilities_check_field_match (_tmp1_, _tmp3_, "sub-uri")) {
#line 60 "../src/ZGUtilities.vala"
		result = FALSE;
#line 60 "../src/ZGUtilities.vala"
		return result;
#line 269 "ZGUtilities.c"
	}
#line 63 "../src/ZGUtilities.vala"
	_tmp4_ = zeitgeist_subject_get_interpretation (subject);
#line 63 "../src/ZGUtilities.vala"
	_tmp5_ = _tmp4_;
#line 63 "../src/ZGUtilities.vala"
	_tmp6_ = zeitgeist_subject_get_interpretation (template_subject);
#line 63 "../src/ZGUtilities.vala"
	_tmp7_ = _tmp6_;
#line 63 "../src/ZGUtilities.vala"
	if (!security_privacy_utilities_check_field_match (_tmp5_, _tmp7_, "sub-int")) {
#line 64 "../src/ZGUtilities.vala"
		result = FALSE;
#line 64 "../src/ZGUtilities.vala"
		return result;
#line 285 "ZGUtilities.c"
	}
#line 67 "../src/ZGUtilities.vala"
	_tmp8_ = zeitgeist_subject_get_manifestation (subject);
#line 67 "../src/ZGUtilities.vala"
	_tmp9_ = _tmp8_;
#line 67 "../src/ZGUtilities.vala"
	_tmp10_ = zeitgeist_subject_get_manifestation (template_subject);
#line 67 "../src/ZGUtilities.vala"
	_tmp11_ = _tmp10_;
#line 67 "../src/ZGUtilities.vala"
	if (!security_privacy_utilities_check_field_match (_tmp9_, _tmp11_, "sub-mani")) {
#line 68 "../src/ZGUtilities.vala"
		result = FALSE;
#line 68 "../src/ZGUtilities.vala"
		return result;
#line 301 "ZGUtilities.c"
	}
#line 71 "../src/ZGUtilities.vala"
	_tmp12_ = zeitgeist_subject_get_origin (subject);
#line 71 "../src/ZGUtilities.vala"
	_tmp13_ = _tmp12_;
#line 71 "../src/ZGUtilities.vala"
	_tmp14_ = zeitgeist_subject_get_origin (template_subject);
#line 71 "../src/ZGUtilities.vala"
	_tmp15_ = _tmp14_;
#line 71 "../src/ZGUtilities.vala"
	if (!security_privacy_utilities_check_field_match (_tmp13_, _tmp15_, "sub-origin")) {
#line 72 "../src/ZGUtilities.vala"
		result = FALSE;
#line 72 "../src/ZGUtilities.vala"
		return result;
#line 317 "ZGUtilities.c"
	}
#line 75 "../src/ZGUtilities.vala"
	_tmp16_ = zeitgeist_subject_get_mimetype (subject);
#line 75 "../src/ZGUtilities.vala"
	_tmp17_ = _tmp16_;
#line 75 "../src/ZGUtilities.vala"
	_tmp18_ = zeitgeist_subject_get_mimetype (template_subject);
#line 75 "../src/ZGUtilities.vala"
	_tmp19_ = _tmp18_;
#line 75 "../src/ZGUtilities.vala"
	if (!security_privacy_utilities_check_field_match (_tmp17_, _tmp19_, "sub-mime")) {
#line 76 "../src/ZGUtilities.vala"
		result = FALSE;
#line 76 "../src/ZGUtilities.vala"
		return result;
#line 333 "ZGUtilities.c"
	}
#line 79 "../src/ZGUtilities.vala"
	result = TRUE;
#line 79 "../src/ZGUtilities.vala"
	return result;
#line 339 "ZGUtilities.c"
}

gboolean
security_privacy_utilities_check_field_match (const gchar* property,
                                              const gchar* template_property,
                                              const gchar* property_name)
{
	gboolean matches = FALSE;
	gchar* parsed = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean is_negated = FALSE;
	const gchar* _tmp3_;
	gboolean _tmp5_ = FALSE;
	gboolean result;
#line 82 "../src/ZGUtilities.vala"
	g_return_val_if_fail (property_name != NULL, FALSE);
#line 83 "../src/ZGUtilities.vala"
	matches = FALSE;
#line 84 "../src/ZGUtilities.vala"
	_tmp0_ = g_strdup (template_property);
#line 84 "../src/ZGUtilities.vala"
	parsed = _tmp0_;
#line 85 "../src/ZGUtilities.vala"
	if (template_property != NULL) {
#line 365 "ZGUtilities.c"
		gboolean _tmp2_;
#line 85 "../src/ZGUtilities.vala"
		_tmp2_ = security_privacy_utilities_parse_negation (&parsed);
#line 85 "../src/ZGUtilities.vala"
		_tmp1_ = _tmp2_;
#line 371 "ZGUtilities.c"
	} else {
#line 85 "../src/ZGUtilities.vala"
		_tmp1_ = FALSE;
#line 375 "ZGUtilities.c"
	}
#line 85 "../src/ZGUtilities.vala"
	is_negated = _tmp1_;
#line 86 "../src/ZGUtilities.vala"
	_tmp3_ = parsed;
#line 86 "../src/ZGUtilities.vala"
	if (g_strcmp0 (_tmp3_, "") == 0) {
#line 87 "../src/ZGUtilities.vala"
		result = TRUE;
#line 87 "../src/ZGUtilities.vala"
		_g_free0 (parsed);
#line 87 "../src/ZGUtilities.vala"
		return result;
#line 389 "ZGUtilities.c"
	} else {
		const gchar* _tmp4_;
#line 88 "../src/ZGUtilities.vala"
		_tmp4_ = parsed;
#line 88 "../src/ZGUtilities.vala"
		if (g_strcmp0 (_tmp4_, property) == 0) {
#line 89 "../src/ZGUtilities.vala"
			matches = TRUE;
#line 398 "ZGUtilities.c"
		}
	}
#line 92 "../src/ZGUtilities.vala"
	if (is_negated) {
#line 92 "../src/ZGUtilities.vala"
		_tmp5_ = !matches;
#line 405 "ZGUtilities.c"
	} else {
#line 92 "../src/ZGUtilities.vala"
		_tmp5_ = matches;
#line 409 "ZGUtilities.c"
	}
#line 92 "../src/ZGUtilities.vala"
	result = _tmp5_;
#line 92 "../src/ZGUtilities.vala"
	_g_free0 (parsed);
#line 92 "../src/ZGUtilities.vala"
	return result;
#line 417 "ZGUtilities.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1458 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1458 "glib-2.0.vapi"
	end = _tmp0_;
#line 1459 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1459 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1460 "glib-2.0.vapi"
		result = maxlen;
#line 1460 "glib-2.0.vapi"
		return result;
#line 440 "ZGUtilities.c"
	} else {
		gchar* _tmp2_;
#line 1462 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1462 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1462 "glib-2.0.vapi"
		return result;
#line 449 "ZGUtilities.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1469 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1471 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 468 "ZGUtilities.c"
	} else {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 472 "ZGUtilities.c"
	}
#line 1471 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1473 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 478 "ZGUtilities.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1475 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1475 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1475 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 488 "ZGUtilities.c"
	}
#line 1478 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1479 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1480 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 496 "ZGUtilities.c"
	} else {
#line 1482 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 500 "ZGUtilities.c"
	}
#line 1484 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1485 "glib-2.0.vapi"
		len = string_length - offset;
#line 506 "ZGUtilities.c"
	}
#line 1487 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1488 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1488 "glib-2.0.vapi"
	result = _tmp3_;
#line 1488 "glib-2.0.vapi"
	return result;
#line 516 "ZGUtilities.c"
}

gboolean
security_privacy_utilities_parse_negation (gchar** val)
{
	gchar* _tmp0_;
	gboolean result;
#line 95 "../src/ZGUtilities.vala"
	g_return_val_if_fail (*val != NULL, FALSE);
#line 96 "../src/ZGUtilities.vala"
	if (!g_str_has_prefix (*val, "!")) {
#line 97 "../src/ZGUtilities.vala"
		result = FALSE;
#line 97 "../src/ZGUtilities.vala"
		return result;
#line 532 "ZGUtilities.c"
	}
#line 100 "../src/ZGUtilities.vala"
	_tmp0_ = string_substring (*val, (glong) 1, (glong) -1);
#line 100 "../src/ZGUtilities.vala"
	_g_free0 (*val);
#line 100 "../src/ZGUtilities.vala"
	*val = _tmp0_;
#line 101 "../src/ZGUtilities.vala"
	result = TRUE;
#line 101 "../src/ZGUtilities.vala"
	return result;
#line 544 "ZGUtilities.c"
}

static void
_g_free0_ (gpointer var)
{
#line 105 "../src/ZGUtilities.vala"
	var = (g_free (var), NULL);
#line 552 "ZGUtilities.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 105 "../src/ZGUtilities.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 560 "ZGUtilities.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 113 "../src/ZGUtilities.vala"
	return self ? g_object_ref (self) : NULL;
#line 568 "ZGUtilities.c"
}

GHashTable*
security_privacy_utilities_from_variant (GVariant* templates_variant)
{
	GHashTable* blacklist = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GError* _inner_error0_ = NULL;
	GHashTable* result;
#line 104 "../src/ZGUtilities.vala"
	g_return_val_if_fail (templates_variant != NULL, NULL);
#line 105 "../src/ZGUtilities.vala"
	_tmp0_ = g_str_hash;
#line 105 "../src/ZGUtilities.vala"
	_tmp1_ = g_str_equal;
#line 105 "../src/ZGUtilities.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_object_unref0_);
#line 105 "../src/ZGUtilities.vala"
	blacklist = _tmp2_;
#line 590 "ZGUtilities.c"
	{
		GVariantIter* _template_variant_it = NULL;
		GVariantIter* _tmp3_;
		GVariant* template_variant = NULL;
#line 106 "../src/ZGUtilities.vala"
		_tmp3_ = g_variant_iter_new (templates_variant);
#line 106 "../src/ZGUtilities.vala"
		_template_variant_it = _tmp3_;
#line 106 "../src/ZGUtilities.vala"
		while (TRUE) {
#line 601 "ZGUtilities.c"
			GVariantIter* _tmp4_;
			GVariant* _tmp5_;
			GVariant* _tmp6_;
			GVariantIter* iter = NULL;
			GVariant* _tmp7_;
			GVariantIter* _tmp8_;
			gchar* template_id = NULL;
			GVariantIter* _tmp9_;
			GVariant* _tmp10_;
			GVariant* _tmp11_;
			const gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			GVariant* ev_variant = NULL;
			GVariantIter* _tmp15_;
			GVariant* _tmp16_;
			GVariant* _tmp17_;
#line 106 "../src/ZGUtilities.vala"
			_tmp4_ = _template_variant_it;
#line 106 "../src/ZGUtilities.vala"
			_tmp5_ = g_variant_iter_next_value (_tmp4_);
#line 106 "../src/ZGUtilities.vala"
			_g_variant_unref0 (template_variant);
#line 106 "../src/ZGUtilities.vala"
			template_variant = _tmp5_;
#line 106 "../src/ZGUtilities.vala"
			_tmp6_ = template_variant;
#line 106 "../src/ZGUtilities.vala"
			if (!(_tmp6_ != NULL)) {
#line 106 "../src/ZGUtilities.vala"
				break;
#line 633 "ZGUtilities.c"
			}
#line 107 "../src/ZGUtilities.vala"
			_tmp7_ = template_variant;
#line 107 "../src/ZGUtilities.vala"
			_tmp8_ = g_variant_iter_new (_tmp7_);
#line 107 "../src/ZGUtilities.vala"
			iter = _tmp8_;
#line 108 "../src/ZGUtilities.vala"
			_tmp9_ = iter;
#line 108 "../src/ZGUtilities.vala"
			_tmp10_ = g_variant_iter_next_value (_tmp9_);
#line 108 "../src/ZGUtilities.vala"
			_tmp11_ = _tmp10_;
#line 108 "../src/ZGUtilities.vala"
			_tmp12_ = g_variant_get_string (_tmp11_, NULL);
#line 108 "../src/ZGUtilities.vala"
			_tmp13_ = g_strdup (_tmp12_);
#line 108 "../src/ZGUtilities.vala"
			_tmp14_ = _tmp13_;
#line 108 "../src/ZGUtilities.vala"
			_g_variant_unref0 (_tmp11_);
#line 108 "../src/ZGUtilities.vala"
			template_id = _tmp14_;
#line 109 "../src/ZGUtilities.vala"
			_tmp15_ = iter;
#line 109 "../src/ZGUtilities.vala"
			_tmp16_ = g_variant_iter_next_value (_tmp15_);
#line 109 "../src/ZGUtilities.vala"
			ev_variant = _tmp16_;
#line 110 "../src/ZGUtilities.vala"
			_tmp17_ = ev_variant;
#line 110 "../src/ZGUtilities.vala"
			if (_tmp17_ != NULL) {
#line 667 "ZGUtilities.c"
				{
					ZeitgeistEvent* template = NULL;
					GVariant* _tmp18_;
					ZeitgeistEvent* _tmp19_;
					GHashTable* _tmp20_;
					const gchar* _tmp21_;
					gchar* _tmp22_;
					ZeitgeistEvent* _tmp23_;
					ZeitgeistEvent* _tmp24_;
#line 112 "../src/ZGUtilities.vala"
					_tmp18_ = ev_variant;
#line 112 "../src/ZGUtilities.vala"
					_tmp19_ = zeitgeist_event_new_from_variant (_tmp18_, &_inner_error0_);
#line 112 "../src/ZGUtilities.vala"
					template = _tmp19_;
#line 112 "../src/ZGUtilities.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 685 "ZGUtilities.c"
						goto __catch0_g_error;
					}
#line 113 "../src/ZGUtilities.vala"
					_tmp20_ = blacklist;
#line 113 "../src/ZGUtilities.vala"
					_tmp21_ = template_id;
#line 113 "../src/ZGUtilities.vala"
					_tmp22_ = g_strdup (_tmp21_);
#line 113 "../src/ZGUtilities.vala"
					_tmp23_ = template;
#line 113 "../src/ZGUtilities.vala"
					_tmp24_ = _g_object_ref0 (_tmp23_);
#line 113 "../src/ZGUtilities.vala"
					g_hash_table_insert (_tmp20_, _tmp22_, _tmp24_);
#line 111 "../src/ZGUtilities.vala"
					_g_object_unref0 (template);
#line 702 "ZGUtilities.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp25_;
					const gchar* _tmp26_;
#line 111 "../src/ZGUtilities.vala"
					e = _inner_error0_;
#line 111 "../src/ZGUtilities.vala"
					_inner_error0_ = NULL;
#line 115 "../src/ZGUtilities.vala"
					_tmp25_ = e;
#line 115 "../src/ZGUtilities.vala"
					_tmp26_ = _tmp25_->message;
#line 115 "../src/ZGUtilities.vala"
					g_warning ("ZGUtilities.vala:115: %s", _tmp26_);
#line 111 "../src/ZGUtilities.vala"
					_g_error_free0 (e);
#line 722 "ZGUtilities.c"
				}
				__finally0:
#line 111 "../src/ZGUtilities.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 111 "../src/ZGUtilities.vala"
					_g_variant_unref0 (ev_variant);
#line 111 "../src/ZGUtilities.vala"
					_g_free0 (template_id);
#line 111 "../src/ZGUtilities.vala"
					_g_variant_iter_free0 (iter);
#line 111 "../src/ZGUtilities.vala"
					_g_variant_unref0 (template_variant);
#line 111 "../src/ZGUtilities.vala"
					_g_variant_iter_free0 (_template_variant_it);
#line 111 "../src/ZGUtilities.vala"
					_g_hash_table_unref0 (blacklist);
#line 111 "../src/ZGUtilities.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 111 "../src/ZGUtilities.vala"
					g_clear_error (&_inner_error0_);
#line 111 "../src/ZGUtilities.vala"
					return NULL;
#line 745 "ZGUtilities.c"
				}
			}
#line 106 "../src/ZGUtilities.vala"
			_g_variant_unref0 (ev_variant);
#line 106 "../src/ZGUtilities.vala"
			_g_free0 (template_id);
#line 106 "../src/ZGUtilities.vala"
			_g_variant_iter_free0 (iter);
#line 754 "ZGUtilities.c"
		}
#line 106 "../src/ZGUtilities.vala"
		_g_variant_unref0 (template_variant);
#line 106 "../src/ZGUtilities.vala"
		_g_variant_iter_free0 (_template_variant_it);
#line 760 "ZGUtilities.c"
	}
#line 120 "../src/ZGUtilities.vala"
	result = blacklist;
#line 120 "../src/ZGUtilities.vala"
	return result;
#line 766 "ZGUtilities.c"
}

